import { EditorState, Compartment, Transaction, Annotation, EditorSelection } from '@codemirror/state'
import { indentWithTab, undo, redo, history, defaultKeymap, historyKeymap, indentMore, indentLess } from '@codemirror/commands'
import { EditorView, ViewPlugin, lineNumbers, highlightActiveLineGutter, highlightSpecialChars, drawSelection, dropCursor, rectangularSelection, crosshairCursor, highlightActiveLine, keymap } from '@codemirror/view'
import { foldGutter, indentOnInput, syntaxHighlighting, defaultHighlightStyle, bracketMatching, foldKeymap } from '@codemirror/language'
import { highlightSelectionMatches, searchKeymap } from '@codemirror/search'
import { closeBrackets, autocompletion, closeBracketsKeymap, startCompletion, closeCompletion, acceptCompletion, moveCompletionSelection } from '@codemirror/autocomplete'
import { lintKeymap } from '@codemirror/lint'
import * as markdown from '@codemirror/lang-markdown'

export default {
  EditorView,
  Compartment,
  EditorState,
  keymap,
  indentWithTab,
  lineNumbers,
  highlightActiveLineGutter,
  highlightSpecialChars,
  history,
  foldGutter,
  drawSelection,
  dropCursor,
  indentOnInput,
  syntaxHighlighting,
  bracketMatching,
  closeBrackets,
  autocompletion,
  rectangularSelection,
  crosshairCursor,
  highlightActiveLine,
  highlightSelectionMatches,
  closeBracketsKeymap,
  defaultKeymap,
  searchKeymap,
  historyKeymap,
  foldKeymap,
  // completionKeymap,
  lintKeymap,
  undo,
  redo,
  Transaction,
  Annotation,
  defaultHighlightStyle,
  startCompletion,
  closeCompletion,
  moveCompletionSelection,
  acceptCompletion,
  indentMore,
  indentLess,
  EditorSelection,
  ViewPlugin,
  ...markdown
}