export const pageHash = '&tags'

export function Scan(sDoc) {
    let t = []
    let r = /(\s|^)\#([a-z-]+)/gmi
    let m

    while((m = r.exec(sDoc)) !== null) {
        if(m.index === r.lastIndex) {
            r.lastIndex++
        }

        t.push(m[2])
    }

    return t
}

export function List(sDoc) {
    let t = Scan(sDoc)

    return t.map(t => '#' + t).join(', ')
}

// Map<string, []<string, Handle>>
export async function All() {
    let a = new Map()

    for(let [ name, handle ] of app.all.entries()) {
        let ts = Scan(await fs.Text(handle))
        let n = { name, handle }

        for(let t of ts) {
            a.set(t, a.has(t) ? a.get(t).concat(n) : [ n ])
        } 
    }

    return a
}

export async function Rank() {
    let a = await All()

    return [ ...a.entries() ]
        .sort(([ , ans ], [ , bns ]) => ans.length - bns.length)
        .reverse()
        .map(formatRank)
        .join('\n')
}

function formatRank([ sTag, sOccrs ]) {
    return sOccrs.length.toString().padStart(3, ' ') + ' #' + sTag
}